/****************************************************************************
// Name:        dftts.h
// Purpose:     
// Author:     Digital Future
// Modified by: 
// Created:     11/14/2006, Modified 12/19/2007, 01/31/2008, 07/12/2008
// RCS-ID:      
// Copyright:   (C) Digital Future. All rights reserved.
// Licence:     
***************************************************************************/

#ifndef _DFTTS_H_
#define _DFTTS_H_

//#if defined(__cplusplus)
//	extern "C" {
//#endif*/


#if defined(__APPLE__)
	#include "sys/malloc.h" // Mac OS X
#else
	#include <malloc.h> // Linux, Windows
#endif

#include <stdio.h>

#include "dfttsval.h"
#include "dfttslang.h"


#define IMPORT_AS_DLL 0

#define EXPORT_AS_DLL 1

#if defined(WIN32)

	#if !defined(_DllMode)
		#if IMPORT_AS_DLL
			#define _DllMode(_type_)		__declspec( dllimport ) _type_
		#elif EXPORT_AS_DLL
			#define _DllMode(_type_)		__declspec( dllexport ) _type_
		#else
			#define _DllMode(_type_)		_type_
		#endif
	#endif

#else

	#if !defined(_DllMode)
		#if IMPORT_AS_DLL || EXPORT_AS_DLL
			#define _DllMode(_type_)		extern _type_
		#else
			#define _DllMode(_type_)		_type_
		#endif
	#endif
	
	#ifndef HWND
		#define HWND int
	#endif
	
	#ifndef TRUE
		#define TRUE 1
	#endif
	
	#ifndef FALSE
		#define FALSE 0
	#endif

#endif



/*(v 2.0.0)*/
_DllMode(size_t) GetDFTTSNumVoices();

/***DEPRECATED (use GetDFTTSVoice)*******WARNING!!!  YOU MUST MALLOC pInDFTTSVoiceInfoCollection BEFORE USING!!! (v 2.0.0)*/
_DllMode(DFTTSVoiceInfoReturnValue) GetDFTTSInstalledVoices( 
										DFTTSVoiceInfoCollection* pInDFTTSVoiceInfoCollection, 
										size_t* psztNumVoices 
										);

/***DEPRECATED (use GetDFTTSVoice)*******WARNING!!! ALWAYS CALL AFTER GetDFTTSInstalledVoices !!! (cleans the heap alloc by GetDFTTSInstalledVoices) (v 2.0.0)*/
_DllMode(void) CleanDFTTSInstalledVoicesRetrieval( DFTTSVoiceInfoCollection* pInDFTTSVoiceInfoCollection );

/*(v 3.5.0)*/
_DllMode(DFTTSVoiceInfoReturnValue) GetDFTTSVoice( int iVoiceInfoIdIn, 
												    DFTTSVoiceEngineType* pvetOut, 
												    char* szVoiceNameOut, 
													int* piVoiceNameLenOut, 
													int* piVoiceIDOut, 
													unsigned short* plangOut 
													);

/*(v 2.0.0)*/
_DllMode(InitDFTTSEngineReturnValueEx*) InitDFTTSEngineEx( HWND hwndWinOwner,
															char* szNeoSpeechDBFolderPath[NEOSPEECH_NUM_VOICES],
															char* szNeoSpeechLicFilePath[NEOSPEECH_NUM_VOICES] 
															);
/*(v 2.0.0)*/
_DllMode(void) InitDFTTSEngineEx2( HWND hwndWinOwner,
									  char* szNeoSpeechDBFolderPath[NEOSPEECH_NUM_VOICES],
									  char* szNeoSpeechLicFilePath[NEOSPEECH_NUM_VOICES],
									  DFTTSVoiceEngineType* psiLoadedEngines,
									  InitDFTTSEngineReturnValue* psiLoadedEnginesReturnValues 
									  );

/*(v 3.0.0) for managed languages (VB6, .NET, Java) convenience*/
_DllMode(void) InitDFTTSEngineEx3( HWND hwndWinOwner,
									char* szNeoSpeechDBFolderPathKate,
									char* szNeoSpeechDBFolderPathPaul,
									char* szNeoSpeechDBFolderPathMiyu,
									char* szNeoSpeechDBFolderPathShow,
									char* szNeoSpeechDBFolderPathMisaki,
									char* szNeoSpeechDBFolderPathLily,
									char* szNeoSpeechDBFolderPathWang,
									char* szNeoSpeechDBFolderPathJunwoo,
									char* szNeoSpeechDBFolderPathSujin,
									char* szNeoSpeechDBFolderPathYumi,
									char* szNeoSpeechDBFolderPathGyuri,
									char* szNeoSpeechDBFolderPathDayoung,
									char* szNeoSpeechLicFilePathKate,
									char* szNeoSpeechLicFilePathPaul,
									char* szNeoSpeechLicFilePathMiyu,
									char* szNeoSpeechLicFilePathShow,
									char* szNeoSpeechLicFilePathMisaki,
									char* szNeoSpeechLicFilePathLily,
									char* szNeoSpeechLicFilePathWang,
									char* szNeoSpeechLicFilePathJunwoo,
									char* szNeoSpeechLicFilePathSujin,
									char* szNeoSpeechLicFilePathYumi,
									char* szNeoSpeechLicFilePathGyuri,
									char* szNeoSpeechLicFilePathDayoung,
									DFTTSVoiceEngineType* psiLoadedEngines,
									InitDFTTSEngineReturnValue* psiLoadedEnginesReturnValues					
									);

_DllMode(UninitDFTTSEngineReturnValue) UninitDFTTSEngine();

/*(v 3.5.0)* for managed languages (VB6, .NET, Java) convenience, for unmanaged languages see dfttslang.h for macros*/
_DllMode(unsigned short) MakeLanguage( unsigned short mainlang, 
									    unsigned short sublang 
										);
/*(v 3.5.0) for managed languages (VB6, .NET, Java) convenience, for unmanaged languages see dfttslang.h for macros*/
_DllMode(unsigned short) GetMainLanguage( unsigned short lang );

/*(v 3.5.0) for managed languages (VB6, .NET, Java) convenience, for unmanaged languages see dfttslang.h for macros*/
_DllMode(unsigned short) GetSubLanguage( unsigned short lang );

_DllMode(LoadDFTTSUserDictReturnValue) LoadDFTTSUserDict( int iDictIndex, 
															  const char* szDictName, 
															  const char* szDictFileName, 
															  DFTTSVoiceEngineType vet, 
															  unsigned short lang,
															  const char* szVoiceName, 
															  const char* szDictContents 
															  );

_DllMode(UnloadDFTTSUserDictReturnValue) UnloadDFTTSUserDict( int iDictIndex,
																const char* szDictName, 
																DFTTSVoiceEngineType vet,
																unsigned short lang 
																);
/*(modified v 3.0.0)*/
_DllMode(DFTTSSpeakReturnValue) DFTTSSpeak( HWND hwndWinOwner,
										     DFTTSVoiceEngineType vet,
										     const char* szVoiceName,
										     int iVoiceID,
											 unsigned short lang,
											 char* szText,
											 int iPitch,
											 int iSpeed,
											 int iVolume,
											 int iPause,
											 int iDictID,
											 DFTTSTextType ttTextType,
											 short ofOutPutFormat
											 );

/*(modified v 3.5.0)*/
_DllMode(DFTTSPauseReturnValue) DFTTSPause( DFTTSVoiceEngineType vet, 
												unsigned short lang = LANG_SUBLANG_NEUTRAL
												);

/*(modified v 3.5.0)*/
_DllMode(DFTTSResumeReturnValue) DFTTSResume( DFTTSVoiceEngineType vet, 
												unsigned short lang = LANG_SUBLANG_NEUTRAL
												);

/*(modified v 3.5.0)*/
_DllMode(DFTTSStopReturnValue) DFTTSStop( DFTTSVoiceEngineType vet, 
											unsigned short lang = LANG_SUBLANG_NEUTRAL
											);

/*(v 3.0.0)*/
_DllMode(DFTTSExportReturnValue) DFTTSExportToFile( DFTTSVoiceEngineType vet,
														const char* szVoiceName,
														int iVoiceID,
														unsigned short lang,
														char* szText,
														int iPitch,
														int iSpeed,
														int iVolume,
														int iPause,
														int iDictID,
														DFTTSTextType ttTextType,
														const char* szFilePath, 
														void* FileFormat
														);

/*(v 3.0.0)*/
_DllMode(DFTTSExportReturnValue) DFTTSExportToFileEx( DFTTSVoiceEngineType vet,
														const char* szVoiceName,
														int iVoiceID,
														unsigned short lang,
														char* szText,
														int iPitch,
														int iSpeed,
														int iVolume,
														int iPause,
														int iDictID,
														DFTTSTextType ttTextType,
														const char* szFilePath, 
														short ffFileFormat, 
														const char* szAudioEncoding,
														int iAudioSamplingRate,
														int iAudioChannels 
														);

_DllMode(DFTTSExportReturnValue) DFTTSExportToBuffer( DFTTSVoiceEngineType vet,
														const char* szVoiceName,
														int iVoiceID,
														unsigned short lang, 
														char* szText,
														char* szBuffer,
														int* piBufferLen,
														int iFrameFlag,
														int iThreadID,
														int iPitch,
														int iSpeed,
														int iVolume,
														int iPause,
														int iDictID,
														DFTTSTextType ttTextType, 
														void* FileFormat
														);

_DllMode(DFTTSParamInfoReturnValue) GetDFTTSEngineInfo( DFTTSVoiceEngineType vet,
															unsigned short lang, 
															short ttspParam,
															void* Value,
															int iValueSize,
															const char* szNeoSpeechLicFilePath 
															);

/*(v 3.0.0)*/
_DllMode(void) SetDFTTSOnWordCallBack( DFTTSOnWordCallBack* DFTTSOnWordCallBackFunc );

/*(v 3.0.0)*/
_DllMode(void) SetDFTTSOnExportCallBack( DFTTSOnExportCallBack* DFTTSOnExportCallBackFunc );

/*#if defined(__cplusplus)
	}
#endif*/
//}

#endif /*_DFTTS_H_*/
